/*
	Juiz Slicing Doors
	Plugin by Geoffrey Crofte
	http://jq.creativejuiz.fr
	Free for personal use (cc)
	
	More info about license : http://jq.creativejuiz.fr/plugins-jquery/slicing-doors.php
*/

// jQuery Easing v1.3 - http://gsgd.co.uk/sandbox/jquery/easing/
;jQuery.easing.jswing=jQuery.easing.swing; jQuery.extend(jQuery.easing,{def:"easeOutQuad",swing:function(e,a,c,b,d){return jQuery.easing[jQuery.easing.def](e,a,c,b,d)},easeInQuad:function(e,a,c,b,d){return b*(a/=d)*a+c},easeOutQuad:function(e,a,c,b,d){return-b*(a/=d)*(a-2)+c},easeInOutQuad:function(e,a,c,b,d){if((a/=d/2)<1)return b/2*a*a+c;return-b/2*(--a*(a-2)-1)+c},easeInCubic:function(e,a,c,b,d){return b*(a/=d)*a*a+c},easeOutCubic:function(e,a,c,b,d){return b*((a=a/d-1)*a*a+1)+c},easeInOutCubic:function(e,a,c,b,d){if((a/=d/2)<1)return b/ 2*a*a*a+c;return b/2*((a-=2)*a*a+2)+c},easeInQuart:function(e,a,c,b,d){return b*(a/=d)*a*a*a+c},easeOutQuart:function(e,a,c,b,d){return-b*((a=a/d-1)*a*a*a-1)+c},easeInOutQuart:function(e,a,c,b,d){if((a/=d/2)<1)return b/2*a*a*a*a+c;return-b/2*((a-=2)*a*a*a-2)+c},easeInQuint:function(e,a,c,b,d){return b*(a/=d)*a*a*a*a+c},easeOutQuint:function(e,a,c,b,d){return b*((a=a/d-1)*a*a*a*a+1)+c},easeInOutQuint:function(e,a,c,b,d){if((a/=d/2)<1)return b/2*a*a*a*a*a+c;return b/2*((a-=2)*a*a*a*a+2)+c},easeInSine:function(e, a,c,b,d){return-b*Math.cos(a/d*(Math.PI/2))+b+c},easeOutSine:function(e,a,c,b,d){return b*Math.sin(a/d*(Math.PI/2))+c},easeInOutSine:function(e,a,c,b,d){return-b/2*(Math.cos(Math.PI*a/d)-1)+c},easeInExpo:function(e,a,c,b,d){return a==0?c:b*Math.pow(2,10*(a/d-1))+c},easeOutExpo:function(e,a,c,b,d){return a==d?c+b:b*(-Math.pow(2,-10*a/d)+1)+c},easeInOutExpo:function(e,a,c,b,d){if(a==0)return c;if(a==d)return c+b;if((a/=d/2)<1)return b/2*Math.pow(2,10*(a-1))+c;return b/2*(-Math.pow(2,-10*--a)+2)+c}, easeInCirc:function(e,a,c,b,d){return-b*(Math.sqrt(1-(a/=d)*a)-1)+c},easeOutCirc:function(e,a,c,b,d){return b*Math.sqrt(1-(a=a/d-1)*a)+c},easeInOutCirc:function(e,a,c,b,d){if((a/=d/2)<1)return-b/2*(Math.sqrt(1-a*a)-1)+c;return b/2*(Math.sqrt(1-(a-=2)*a)+1)+c},easeInElastic:function(e,a,c,b,d){var e=1.70158,f=0,g=b;if(a==0)return c;if((a/=d)==1)return c+b;f||(f=d*0.3);g<Math.abs(b)?(g=b,e=f/4):e=f/(2*Math.PI)*Math.asin(b/g);return-(g*Math.pow(2,10*(a-=1))*Math.sin((a*d-e)*2*Math.PI/f))+c},easeOutElastic:function(e, a,c,b,d){var e=1.70158,f=0,g=b;if(a==0)return c;if((a/=d)==1)return c+b;f||(f=d*0.3);g<Math.abs(b)?(g=b,e=f/4):e=f/(2*Math.PI)*Math.asin(b/g);return g*Math.pow(2,-10*a)*Math.sin((a*d-e)*2*Math.PI/f)+b+c},easeInOutElastic:function(e,a,c,b,d){var e=1.70158,f=0,g=b;if(a==0)return c;if((a/=d/2)==2)return c+b;f||(f=d*0.3*1.5);g<Math.abs(b)?(g=b,e=f/4):e=f/(2*Math.PI)*Math.asin(b/g);if(a<1)return-0.5*g*Math.pow(2,10*(a-=1))*Math.sin((a*d-e)*2*Math.PI/f)+c;return g*Math.pow(2,-10*(a-=1))*Math.sin((a*d-e)* 2*Math.PI/f)*0.5+b+c},easeInBack:function(e,a,c,b,d,f){f==void 0&&(f=1.70158);return b*(a/=d)*a*((f+1)*a-f)+c},easeOutBack:function(e,a,c,b,d,f){f==void 0&&(f=1.70158);return b*((a=a/d-1)*a*((f+1)*a+f)+1)+c},easeInOutBack:function(e,a,c,b,d,f){f==void 0&&(f=1.70158);if((a/=d/2)<1)return b/2*a*a*(((f*=1.525)+1)*a-f)+c;return b/2*((a-=2)*a*(((f*=1.525)+1)*a+f)+2)+c},easeInBounce:function(e,a,c,b,d){return b-jQuery.easing.easeOutBounce(e,d-a,0,b,d)+c},easeOutBounce:function(e,a,c,b,d){return(a/=d)<1/ 2.75?b*7.5625*a*a+c:a<2/2.75?b*(7.5625*(a-=1.5/2.75)*a+0.75)+c:a<2.5/2.75?b*(7.5625*(a-=2.25/2.75)*a+0.9375)+c:b*(7.5625*(a-=2.625/2.75)*a+0.984375)+c},easeInOutBounce:function(e,a,c,b,d){if(a<d/2)return jQuery.easing.easeInBounce(e,a*2,0,b,d)*0.5+c;return jQuery.easing.easeOutBounce(e,a*2-d,0,b,d)*0.5+b*0.5+c}});

// juiz function

(function($){
	$.fn.juizSlicingDoors = function(args) {

		
		var defaultSettings= {
			//Custom settings
			'nbDoors'			: 4, //4, 2, 1 (>4=4, 3=2, <1=1)
			'animOrientation'	: 'vertical', // vertical, top, left, bottom, right, (horizontal)
			'hideEffect'		: 'easeOutBounce',
			'showEffect'		: 'jswing',
			'hideDuration'			: 800,
			'showDuration'			: 300	
		},
		jz = $.extend({}, defaultSettings, args);

		
		$(this).each(function () {

			//Calculation for corners
			var negWidth = Math.round($(this).width() / 2) * (-1),
				posWidth = negWidth * (-1),
				outWidth = posWidth * 2,
				negHeight = Math.round($(this).height() / 2) * (-1),
				posHeight = negHeight * (-1),
				outHeight = posHeight * 2,
				img = $(this).find('img').attr('src'),
				alt = $(this).find('img').attr('img');
			
			$(this).attr("tabindex","1");
			$('img', this).remove();
			$(this).append('<div class="juizPart topLeft"></div><div class="juizPart topRight"></div><div class="juizPart bottomLeft"></div><div class="juizPart bottomRight"></div>');
			$(this).children('div.juizPart').css('background-image','url('+ img + ')');

			$('div.topLeft',$(this)).css({top:0, left:0, width:posWidth , height:posHeight});	
			$('div.topRight',$(this)).css({top:0, left:posWidth, width:posWidth , height:posHeight});	
			$('div.bottomLeft',$(this)).css({bottom:0, left:0, width:posWidth , height:posHeight});	
			$('div.bottomRight',$(this)).css({bottom:0, left:posWidth, width:posWidth , height:posHeight});



			$(this).hover(function () {
				if(jz.nbDoors<4 && jz.nbDoors>=2) {
					
					// animation pour 2 portes
					
					if(jz.animOrientation=='vertical') {
						// animation verticale
						$('div.topLeft, div.topRight',$(this)).stop(true, true).animate({top:negHeight}, {duration:jz.showDuration, easing:jz.showEffect});	
						$('div.bottomLeft, div.bottomRight',$(this)).stop(true, true).animate({bottom:negHeight}, {duration:jz.showDuration, easing:jz.showEffect});	
					}
					else {
						// animation horizontale
						$('div.topLeft, div.bottomLeft',$(this)).stop(true, true).animate({left:negWidth}, {duration:jz.showDuration, easing:jz.showEffect});	
						$('div.topRight, div.bottomRight',$(this)).stop(true, true).animate({left:outWidth}, {duration:jz.showDuration, easing:jz.showEffect});
					}
				}
				else if(jz.nbDoors<2) {
					// animation pour 1 porte
					if(jz.animOrientation=='top') {
						// animation vers le haut
						$('div.topLeft, div.topRight',$(this)).stop(true, true).animate({top:negHeight*2}, {duration:jz.showDuration, easing:jz.showEffect});
						$('div.bottomLeft, div.bottomRight',$(this)).stop(true, true).animate({bottom:-negHeight*2}, {duration:jz.showDuration, easing:jz.showEffect});
					}
					else if(jz.animOrientation=='left') {
						// animation vers la gauche
						$('div.juizPart',$(this)).stop(true, true).animate({left:negWidth*2}, {duration:jz.showDuration, easing:jz.showEffect});	
					}
					else if(jz.animOrientation=='right') {
						// animation vers la droite
						$('div.juizPart',$(this)).stop(true, true).animate({left:-negWidth*2}, {duration:jz.showDuration, easing:jz.showEffect});	
					}
					else {
						// animation vers le bas
						$('div.topLeft, div.topRight',$(this)).stop(true, true).animate({top:-negHeight*2}, {duration:jz.showDuration, easing:jz.showEffect});
						$('div.bottomLeft, div.bottomRight',$(this)).stop(true, true).animate({bottom:negHeight*2}, {duration:jz.showDuration, easing:jz.showEffect});
					}
				}
				else {
					// animation pour 4 portes
					$('div.topLeft',$(this)).stop(true, true).animate({top:negHeight, left:negWidth}, {duration:jz.showDuration, easing:jz.showEffect});	
					$('div.topRight',$(this)).stop(true, true).animate({top:negHeight, left:outWidth}, {duration:jz.showDuration, easing:jz.showEffect});	
					$('div.bottomLeft',$(this)).stop(true, true).animate({bottom:negHeight, left:negWidth}, {duration:jz.showDuration, easing:jz.showEffect});	
					$('div.bottomRight',$(this)).stop(true, true).animate({bottom:negHeight, left:outWidth}, {duration:jz.showDuration, easing:jz.showEffect});
				}
						
			},
			function () {

				$('div.topLeft',$(this)).stop(true, true).animate({top:0, left:0}, {duration:jz.hideDuration, easing:jz.hideEffect});	
				$('div.topRight',$(this)).stop(true, true).animate({top:0, left:posWidth}, {duration:jz.hideDuration, easing:jz.hideEffect});	
				$('div.bottomLeft',$(this)).stop(true, true).animate({bottom:0, left:0}, {duration:jz.hideDuration, easing:jz.hideEffect});	
				$('div.bottomRight',$(this)).stop(true, true).animate({bottom:0, left:posWidth}, {duration:jz.hideDuration, easing:jz.hideEffect});	
			
			})
			.click(function () { if($('a',$(this)).size()>0) { window.location = $('a',$(this)).attr('href'); } })
			.focus(function() { $(this).trigger("mouseenter"); })
			.blur(function() { $(this).trigger("mouseleave"); });

		});
		
	
	} // fin de la fonction

})(jQuery);